package nographics;

/**
 * Controller of the cars that try to enter and leave the bridge.
 * 
 * @author unknown
 */
public class Controller {
    private int red; // number of red cars on the bridge
    private int blue; // number of blue cars on the bridge
    
    /**
     * Initializes this controller.
     */
    public Controller () {
	this.red = 0;
	this.blue = 0;
    }
    
    /**
     * Handles a car that tries to enter the bridge from the left.
     */
    public synchronized void enterLeft() {
	//System.out.println("Car enters the bridge from the left");
	while (this.blue > 0) {
	    try {
		this.wait();
	    } catch (InterruptedException e) {}
	}
	this.red++;
    }
    
    /**
     * Handles a car that tries to enter the bridge from the right.
     */
    public synchronized void enterRight() {
	//System.out.println("Car enters the bridge from the right");
	while (this.red > 0) {
	    try {
		this.wait();
	    } catch (InterruptedException e) {}
	}
	this.blue++;
    }
    
    /**
     * Handles a car that leaves the bridge at the left.
     */
    public synchronized void leaveLeft() {
	//System.out.println("Car leaves the bridge at the left");
	this.blue--;
	if (this.blue == 0) {
	    this.notify();
	}
    }
    
    /**
     * Handles a car that leaves the bridge at the right.
     */
    public synchronized void leaveRight() {
	//System.out.println("Car leaves the bridge at the right");
	this.red--;
	if (this.red == 0) {
	    this.notify();
	}
    }
}
