package nographics;

import java.util.ArrayList;
import java.util.List;

import static nographics.Car.LEFT_PARKING;
import static nographics.Car.RIGHT_PARKING;

/**
 * A world consisting of a bridge, a controller, and cars.
 * 
 * @author unknown
 */
public class World {
    private Controller controller; // controller
    private List<Car> redCars; // red cars
    private List<Car> blueCars; // blue cars

    /**
     * Initializes this world.
     */
    public World() {
	this.controller = new Controller();
	this.redCars = new ArrayList<Car>();
	this.redCars.add(new Car(RIGHT_PARKING)); // add dummy car as first red car
	this.blueCars = new ArrayList<Car>();
	this.blueCars.add(new Car(LEFT_PARKING)); // add dummy car as first blue car
    }

    /**
     * Add a car with the given colour to this world.
     * 
     * @param colour colour of the car
     */
    public void addCar(Colour colour) {
	Car car;
	if (colour == Colour.RED) {
	    car = new Car(colour, this.redCars.get(this.redCars.size() - 1), this.controller);
	    this.redCars.add(car);
	} else {
	    car = new Car(colour, this.blueCars.get(this.blueCars.size() - 1), this.controller);
	    this.blueCars.add(car);
	}
	car.start();
    }
}
